C******** recherche des ancetres communs a un groupe de reference
c ce programme lit un fichier de pedigree restreint aux ancetres d'un 
c groupe de reference ; determine les ancetres communs a ce groupe 
c (fichier sortie) et les ancetres des parents des individus de ce groupe
c (fichier sortie_parent)
c il reconstruit ensuite le pedigree minimal entre le groupe de reference
c et chacun de ces ancetres (fichiers ped_x)
c enfin il construit toutes les chaines de parente (fichiers graph_x)

      program anc_comm
      implicit none
      
      integer(kind=4),dimension(:),allocatable:: prc,mrc,ndes,ord,list 
      integer(kind=4),dimension(:),allocatable:: ngen,listp,lan,ij,mc,pc   
      real(kind=8),dimension(:),allocatable :: prob
      character(len=14),dimension(:),allocatable::anim
      logical,dimension(:),allocatable::pop
      integer i,j,k,l,n, nl, nbit,ip,im,ii,npop,npopp,jj,ir,nc,io
      integer ic,necr,necrp,icm,icp,icmp,ifail,ll,ik,iz,nq,is,pos
      logical t
      character*128 str,sts,stsp,sti,jour,nfich,ngraph
      character*80 fmt98,fmt99
      character*5 ch
      real*8 x
      integer*8 mem
      character*20 xx
      character*1000:: ligne
      
      integer nan,nut,lll(0:100)
      integer chemin(100)

      include "format.incl"

      call fdate(jour)
      print *
      PRINT 990,jour
      print *
      print *,'Recherche des ancetres communs a un groupe d individus'
      print *,'******************************************************'
      print *

c lecture des noms de fichier
      print *,'Nom du fichier de genealogie ?'
      read(5,*) str
      print *,'Fichier de genealogie : ',trim(str)
      print *
      print *,'Nom du fichier des individus etudies ?'
      read(5,*) sti
      print *,'Fichier etudie : ',trim(sti)
      print *
      print *,'Nom du fichier sortie ?'
      read(5,*) sts
      print *,'Fichier des ancetres des individus etudies : ',trim(sts)
      stsp=trim(sts)//'_parent'
      print *,'Fichier des ancetres de leurs parents      : ',stsp
 
      pos=1
      print *,'Rang de la variable identifiant animal ?'
      read(5,*,iostat=io) pos
      if (io.eq.0.and.pos.gt.3) then
        open (1,file=str,form='FORMATTED')
        read (1,'(a1000)') ligne
        call lecligne(ligne,nc)
        if (pos.gt.nc) pos=1
        close(1)
        end if      

      print *,'Rang de la variable Identifiant : ',pos  

      nl=0
      open (1,file=str,form='FORMATTED')
      do
        read (1,*,iostat=io) i,j,k
        if (io.ne.0) exit
	nl=nl+1
        if (i.ne.nl) then
          print 102,nl,i
          stop
          end if
	end do
      print 900,nl
      close(1)
      mem=nl
      mem=1 + 280*mem/1074000000
      print *,'Memory required for allocation (Gb) : ', mem

      allocate(prc(nl),mrc(nl),ndes(nl),ord(nl),list(nl))
      allocate(ngen(nl),listp(nl),lan(nl),ij(nl),mc(nl),pc(nl))
      allocate(prob(nl),anim(nl),pop(nl))
      

c lecture du fichier de pedigree
      open (1,file=str,form='FORMATTED')

      do i=1,nl
       if (pos.eq.1) then
         read (1,*) ii,ip,im
         write(anim(i),'(i0)') ii
       else
         read (1,*) ii,ip,im,(xx,j=1,pos-4),anim(i)
         end if
       if (ip.gt.nl.or.im.gt.nl) then
          print 101
          stop
          end if
       prc(i)=ip
       if (ip.lt.0) prc(i)=0
       mrc(i)=im
       if (im.lt.0) mrc(i)=0
       end do

      close(1)
      
c lecture du fichier etudie
      npop=0    ! nb d individus analyses
      npopp=0   ! nb de parents des individus analyses
      do i=1, nl
         pop(i)=.false.   ! individus analyses
         ndes(i)=0        ! nbre de produits
         end do

      open (2,file=sti,form='FORMATTED')
      do
       read (2,*,iostat=io) i
       if (io.ne.0) exit
       Npop=Npop+1
       if (i.gt.nl) then
          print 101
          stop
          end if
       pop(i)=.true.
       list(npop)=i

       if (prc(i).gt.0) then
        npopp=npopp+1
        listp(npopp)=prc(i)
        end if
       if (mrc(i).gt.0) then
        npopp=npopp+1
        listp(npopp)=mrc(i)
        end if
       end do 

      print 8511, npop
      icm=npop*4/5
      if (npop.lt.5) icm=npop
      close(2)

c tri des parents et suppression des doubles
      call ipsort(listp,npopp,ord,2,ifail)

c      call m01dbf(listp,1,npopp,'A',ord,ifail)
c      call m01ebf(listp,1,npopp,ord,ifail)
      j=1
      do i=2, npopp
        if (listp(i).gt.listp(j)) then
          j=j+1
          listp(j)=listp(i)
          end if
        end do

      npopp=j
      print *,'Nombre de parents des individus etudies : ',npopp
      icmp=npopp*4/5
      if (npopp.lt.5) icmp=npopp

c calcul du nbre de descendants
      k=0
      do i=1, nl
        if (prc(i).ne.0) ndes(prc(i))=ndes(prc(i)) + 1
        if (mrc(i).ne.0) ndes(mrc(i))=ndes(mrc(i)) + 1
        end do
c      do i=1, nl
c        if (ndes(i).eq.0) k=k + 1
c        end do
c      print 7003, k

c recherche de l ordre tel que parent est avant produit
      k=0
      do i=1, nl
        ngen(i)=-1
        if (prc(i).eq.0 .and. mrc(i).eq.0)  then
            ngen(i)=0
            k=k+1
            ord(k)=i
        end if
      end do
      nbit=0
c on suppose que le pedigree est trie en moins de 50 boucles
      do while(k.lt.nl .and. nbit.le.50)
        nbit=nbit+1
        j=0
        do i=1, nl
          if (ngen(i).lt.0) then
            ip=prc(i)
            im=mrc(i)
            t=.true.
            if (ip.ne.0 .and. ngen(ip).lt.0) t=.false.
            if (im.ne.0 .and. ngen(im).lt.0) t=.false.
            if (t) then
              if (ip.eq.0) then
                ii=0
              else
                ii=ngen(ip)
              end if
              if (im.ne.0) ii=max(ii,ngen(im))
              ngen(i) = ii+1
              k=k+1
              ord(k)=i
              j=j+1
            end if
          end if
        end do
c        print 1000,nbit,k,j,nl-k
      end do

c verification que le pedigree est plausible
      j=0
      if (k.lt.nl) then
        print 1104, nl-k
        do i=1,nl
          if (ngen(i).lt.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',i,prc(i),mrc(i)
            prc(i)=0
            mrc(i)=0
            ngen(i)=0
            k=k+1
            ord(k)=i
            end if
        end do
       end if


c on calcule la contribution de chaque individu a tous ses descendants
      open (3,file=sts,form='formatted')
      open (4,file=stsp,form='formatted')
      print *
      print *

      fmt98='(''        Indiv          Pere    Mere  nd contri'',500i6)'
      fmt99='(a14,1x,3i8,i5,f6.1,100f6.2)'
      write (3,fmt98) (list(i),i=1,npop)
      write (4,fmt98) (listp(i),i=1,npopp)
      necr=0 ; necrp=0 ; nan=0

      DO II=1, NL
       IF (NDES(II).GT.0) THEN

        do i=1, nl
          prob(i)=0.d0
          end do      
        prob(ii)=1.d0

        do k=1,nl
          i=ord(k)
          ip=prc(i)
          im=mrc(i)
          if (ip.ne.0) prob(i)=prob(i) + prob(ip)*.5d0
          if (im.ne.0) prob(i)=prob(i) + prob(im)*.5d0
          end do
        
        ic=0
        x=0.d0

c on determine ensuite la contribution de cet ancetre a chaque individu de ref
c on l ecrit dans sortie s il contribue a au moins icm individus
        do i=1, npop
          j=list(i)
          if (prob(j).gt.0.d0) then
            ic=ic+1
            x=x+prob(j)
            end if
          end do
        if (ic.ge.icm) then
          necr=necr+1
          write (3,fmt99) anim(ii),ii,prc(ii),mrc(ii),
     *              ic,100.*x/ic,(100.*prob(list(i)),i=1,npop)
          end if

c on l ecrit dans sortie_parent s il contribue a au moins icmp parents d individus
        ic=0
	x=0.d0
        do i=1, npopp
          j=listp(i)
          if (prob(j).gt.0.d0) then
            ic=ic+1
            x=x+prob(j)
            end if
          end do
        if (ic.ge.icmp) then
c	  if (ic.eq.npopp) then  ! modif icmp 8/15
	    nan=nan+1
	    lan(nan)=ii
	    print '(i4,1x,a14,4i6)',nan,anim(ii),ii,prc(ii),mrc(ii),ic
c	    end if
          necrp=necrp+1
          write (4,fmt99) anim(ii),ii,prc(ii),mrc(ii),
     *              ic,100.*x/ic,(100.*prob(listp(i)),i=1,npopp)
          end if

       END IF
      END DO

      close (3)
      close (4)

      print *
      print *,'fichier ',trim(sts),' : ', necr,
     *  ' ancetres ecrits contribuant pour (au moins)',
     *  icm,' individus etudies'
      print *,'fichier ',trim(stsp),' : ', necrp,
     *  ' ancetres ecrits contribuant pour (au moins)',
     *  icmp,' parents d individus etudies'

c      print *,'nan',nan,(lan(i),i=1,nan)


c construction des pedigree utiles minimum issus des nan ancetres contribuant
c a TOUS les parents d'individus de reference
c creation d un fichier de pedigree ped_x par ancetre x
      
      do ii=1, nan
        jj=lan(ii)
	do i=1,nl
	  ij(i)=i 
	  pc(i)=prc(i)
	  mc(i)=mrc(i)
	  end do
	nbit=0
	k=1
c elimination des animaux inutiles
	do while (nbit.lt.50.and.k.gt.0)  
          k=0
	  nbit=nbit+1
	  do i=1,nl
	   if (ij(i).gt.0) then
	    if (pc(i).eq.0.and.mc(i).eq.0.and.i.ne.jj) then
	      ij(i)=0
              k=k+1
	      end if
      
	    if (pc(i).gt.0.and.ij(pc(i)).eq.0) then
	       pc(i)=0
	       k=k+1
	       end if
	    if (mc(i).gt.0.and.ij(mc(i)).eq.0) then
	       mc(i)=0
	       k=k+1
	       end if	  
	    end if   
	  end do
c	  print *,nbit,k
	  end do

	 write (ch,'(i0)') ii
	 nfich='ped_'//ch
	 open (9,file=nfich,form='formatted')

	 necr=0
	 do i=1,nl
	    if (ij(i).gt.0) then
	      write (9,'(3i8,1x,a14)') ij(i),pc(i),mc(i),anim(i)
	      necr=necr+1
	      end if
	    end do
	 print *
	 print '(i6,a39,i8,1x,a14,a17,a30)',
     *   necr,' enregistrements ecrits pour l ancetre ',jj,anim(jj),
     * 	 ' dans le fichier ',trim(nfich)    
	 close(9)   


c construction des differents chemins entre chaque individu et cet ancetre x (graph_x)	  
c        ngraph='graph_'//ch
c        open (8,file=ngraph,form='formatted')
c        necr=0

c	do ik=1, npop
c	  jj=list(ik)
c	  nq=1
c          lll(1)=jj
c	  iz=jj  ; ir=1

c	  do while (iz.gt.0)
c           i=iz
c	    j=ir
c	    ir=1
c            if (j.eq.1) then      ! on cherche le pere de i
c	         iz=pc(i)
c                 if (iz.eq.0) j=2
c		 end if
c            if (j.eq.2) then      ! on cherche la mere de i
c	         iz=mc(i)
c		 end if

c            if (iz.gt.0) then     ! on ajoute ce parent a la chaine
c		chemin(nq)=j      ! 1=pere, 2=mere
c	        nq=nq+1
c		lll(nq)=iz        ! liste de la chaine
c		i=iz
c               end if

c            if (lll(nq).eq.lan(ii)) then   ! on imprime la chaine si on arrive a lan(ii)
c	        write (8,'(I4,1x,100(a14,1x))') nq,(anim(lll(k)),k=1,nq)
c               necr=necr+1
c                iz=0
c                end if

c            if (iz.eq.0.and.nq.gt.0) then ! on repart sur une autre chaine du meme produit
c                         !  pour cela, on redescend jusqu'au premier chemin 2 non parcouru	
c	        nq=nq-1
c	        do while (nq.gt.0.and.chemin(nq).eq.2)
c		   nq=nq-1
c		   end do
c		ir=2 ; iz=lll(nq)
c		end if

c            print *,ik,jj,j,nq,(chemin(k),k=1,nq),iz			
c	    end do
c	  end do
c	print *
c	close(8)  		 		 
c	print *,necr,' chaines ecrites pour l ancetre ',lan(ii),
c    *  'dans le fichier ',trim(ngraph)        
	end do          
	         	    
      print *
      print *
      call fdate(jour)
      print *
      PRINT 991,jour



      stop
      END
      
*DECK IPPERM
      SUBROUTINE IPPERM (IX, N, IPERM, IER)
C***BEGIN PROLOGUE  IPPERM
C***PURPOSE  Rearrange a given array according to a prescribed
C            permutation vector.
C***LIBRARY   SLATEC
C***CATEGORY  N8
C***TYPE      INTEGER (SPPERM-S, DPPERM-D, IPPERM-I, HPPERM-H)
C***KEYWORDS  APPLICATION OF PERMUTATION TO DATA VECTOR
C***AUTHOR  McClain, M. A., (NIST)
C           Rhoads, G. S., (NBS)
C***DESCRIPTION
C
C         IPPERM rearranges the data vector IX according to the
C         permutation IPERM: IX(I) <--- IX(IPERM(I)).  IPERM could come
C         from one of the sorting routines IPSORT, SPSORT, DPSORT or
C         HPSORT.
C
C     Description of Parameters
C         IX - input/output -- integer array of values to be rearranged.
C         N - input -- number of values in integer array IX.
C         IPERM - input -- permutation vector.
C         IER - output -- error indicator:
C             =  0  if no error,
C             =  1  if N is zero or negative,
C             =  2  if IPERM is not a valid permutation.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   900618  DATE WRITTEN
C   920507  Modified by M. McClain to revise prologue text.
C***END PROLOGUE  IPPERM
      INTEGER IX(*), N, IPERM(*), I, IER, INDX, INDX0, ITEMP, ISTRT
C***FIRST EXECUTABLE STATEMENT  IPPERM
      IER=0
      IF(N.LT.1)THEN
         IER=1
         CALL XERMSG ('SLATEC', 'IPPERM',
     +    'The number of values to be rearranged, N, is not positive.',
     +    IER, 1)
         RETURN
      ENDIF
C
C     CHECK WHETHER IPERM IS A VALID PERMUTATION
C
      DO 100 I=1,N
         INDX=ABS(IPERM(I))
         IF((INDX.GE.1).AND.(INDX.LE.N))THEN
            IF(IPERM(INDX).GT.0)THEN
               IPERM(INDX)=-IPERM(INDX)
               GOTO 100
            ENDIF
         ENDIF
         IER=2
         CALL XERMSG ('SLATEC', 'IPPERM',
     +    'The permutation vector, IPERM, is not valid.', IER, 1)
         RETURN
  100 CONTINUE
C
C     REARRANGE THE VALUES OF IX
C
C     USE THE IPERM VECTOR AS A FLAG.
C     IF IPERM(I) > 0, THEN THE I-TH VALUE IS IN CORRECT LOCATION
C
      DO 330 ISTRT = 1 , N
         IF (IPERM(ISTRT) .GT. 0) GOTO 330
         INDX = ISTRT
         INDX0 = INDX
         ITEMP = IX(ISTRT)
  320    CONTINUE
         IF (IPERM(INDX) .GE. 0) GOTO 325
            IX(INDX) = IX(-IPERM(INDX))
            INDX0 = INDX
            IPERM(INDX) = -IPERM(INDX)
            INDX = IPERM(INDX)
            GOTO 320
  325    CONTINUE
         IX(INDX0) = ITEMP
  330 CONTINUE
C
      RETURN
      END
*DECK IPSORT
      SUBROUTINE IPSORT (IX, N, IPERM, KFLAG, IER)
C***BEGIN PROLOGUE  IPSORT
C***PURPOSE  Return the permutation vector generated by sorting a given
C            array and, optionally, rearrange the elements of the array.
C            The array may be sorted in increasing or decreasing order.
C            A slightly modified quicksort algorithm is used.
C***LIBRARY   SLATEC
C***CATEGORY  N6A1A, N6A2A
C***TYPE      INTEGER (SPSORT-S, DPSORT-D, IPSORT-I, HPSORT-H)
C***KEYWORDS  NUMBER SORTING, PASSIVE SORTING, SINGLETON QUICKSORT, SORT
C***AUTHOR  Jones, R. E., (SNLA)
C           Kahaner, D. K., (NBS)
C           Rhoads, G. S., (NBS)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C   IPSORT returns the permutation vector IPERM generated by sorting
C   the array IX and, optionally, rearranges the values in IX.  IX may
C   be sorted in increasing or decreasing order.  A slightly modified
C   quicksort algorithm is used.
C
C   IPERM is such that IX(IPERM(I)) is the Ith value in the
C   rearrangement of IX.  IPERM may be applied to another array by
C   calling IPPERM, SPPERM, DPPERM or HPPERM.
C
C   The main difference between IPSORT and its active sorting equivalent
C   ISORT is that the data are referenced indirectly rather than
C   directly.  Therefore, IPSORT should require approximately twice as
C   long to execute as ISORT.  However, IPSORT is more general.
C
C   Description of Parameters
C      IX - input/output -- integer array of values to be sorted.
C           If ABS(KFLAG) = 2, then the values in IX will be
C           rearranged on output; otherwise, they are unchanged.
C      N  - input -- number of values in array IX to be sorted.
C      IPERM - output -- permutation array such that IPERM(I) is the
C              index of the value in the original order of the
C              IX array that is in the Ith location in the sorted
C              order.
C      KFLAG - input -- control parameter:
C            =  2  means return the permutation vector resulting from
C                  sorting IX in increasing order and sort IX also.
C            =  1  means return the permutation vector resulting from
C                  sorting IX in increasing order and do not sort IX.
C            = -1  means return the permutation vector resulting from
C                  sorting IX in decreasing order and do not sort IX.
C            = -2  means return the permutation vector resulting from
C                  sorting IX in decreasing order and sort IX also.
C      IER - output -- error indicator:
C          =  0  if no error,
C          =  1  if N is zero or negative,
C          =  2  if KFLAG is not 2, 1, -1, or -2.
C***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
C                 for sorting with minimal storage, Communications of
C                 the ACM, 12, 3 (1969), pp. 185-187.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   761101  DATE WRITTEN
C   761118  Modified by John A. Wisniewski to use the Singleton
C           quicksort algorithm.
C   810801  Further modified by David K. Kahaner.
C   870423  Modified by Gregory S. Rhoads for passive sorting with the
C           option for the rearrangement of the original data.
C   890620  Algorithm for rearranging the data vector corrected by R.
C           Boisvert.
C   890622  Prologue upgraded to Version 4.0 style by D. Lozier.
C   891128  Error when KFLAG.LT.0 and N=1 corrected by R. Boisvert.
C   920507  Modified by M. McClain to revise prologue text.
C   920818  Declarations section rebuilt and code restructured to use
C           IF-THEN-ELSE-ENDIF.  (SMR, WRB)
C***END PROLOGUE  IPSORT
C     .. Scalar Arguments ..
      INTEGER IER, KFLAG, N
C     .. Array Arguments ..
      INTEGER IPERM(*), IX(*)
C     .. Local Scalars ..
      REAL R
      INTEGER I, IJ, INDX, INDX0, ISTRT, ITEMP, J, K, KK, L, LM, LMT, M,
     +        NN
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. External Subroutines ..
      EXTERNAL XERMSG
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C***FIRST EXECUTABLE STATEMENT  IPSORT
      IER = 0
      NN = N
      IF (NN .LT. 1) THEN
         IER = 1
         CALL XERMSG ('SLATEC', 'IPSORT',
     +    'The number of values to be sorted, N, is not positive.',
     +    IER, 1)
         RETURN
      ENDIF
      KK = ABS(KFLAG)
      IF (KK.NE.1 .AND. KK.NE.2) THEN
         IER = 2
         CALL XERMSG ('SLATEC', 'IPSORT',
     +    'The sort control parameter, KFLAG, is not 2, 1, -1, or -2.',
     +    IER, 1)
         RETURN
      ENDIF
C
C     Initialize permutation vector
C
      DO 10 I=1,NN
         IPERM(I) = I
   10 CONTINUE
C
C     Return if only one value is to be sorted
C
      IF (NN .EQ. 1) RETURN
C
C     Alter array IX to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 20 I=1,NN
            IX(I) = -IX(I)
   20    CONTINUE
      ENDIF
C
C     Sort IX only
C
      M = 1
      I = 1
      J = NN
      R = .375E0
C
   30 IF (I .EQ. J) GO TO 80
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
   40 K = I
C
C     Select a central element of the array and save it in location L
C
      IJ = I + INT((J-I)*R)
      LM = IPERM(IJ)
C
C     If first element of array is greater than LM, interchange with LM
C
      IF (IX(IPERM(I)) .GT. IX(LM)) THEN
         IPERM(IJ) = IPERM(I)
         IPERM(I) = LM
         LM = IPERM(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than LM, interchange with LM
C
      IF (IX(IPERM(J)) .LT. IX(LM)) THEN
         IPERM(IJ) = IPERM(J)
         IPERM(J) = LM
         LM = IPERM(IJ)
C
C        If first element of array is greater than LM, interchange
C        with LM
C
         IF (IX(IPERM(I)) .GT. IX(LM)) THEN
            IPERM(IJ) = IPERM(I)
            IPERM(I) = LM
            LM = IPERM(IJ)
         ENDIF
      ENDIF
      GO TO 60
   50 LMT = IPERM(L)
      IPERM(L) = IPERM(K)
      IPERM(K) = LMT
C
C     Find an element in the second half of the array which is smaller
C     than LM
C
   60 L = L-1
      IF (IX(IPERM(L)) .GT. IX(LM)) GO TO 60
C
C     Find an element in the first half of the array which is greater
C     than LM
C
   70 K = K+1
      IF (IX(IPERM(K)) .LT. IX(LM)) GO TO 70
C
C     Interchange these elements
C
      IF (K .LE. L) GO TO 50
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 90
C
C     Begin again on another portion of the unsorted array
C
   80 M = M-1
      IF (M .EQ. 0) GO TO 120
      I = IL(M)
      J = IU(M)
C
   90 IF (J-I .GE. 1) GO TO 40
      IF (I .EQ. 1) GO TO 30
      I = I-1
C
  100 I = I+1
      IF (I .EQ. J) GO TO 80
      LM = IPERM(I+1)
      IF (IX(IPERM(I)) .LE. IX(LM)) GO TO 100
      K = I
C
  110 IPERM(K+1) = IPERM(K)
      K = K-1
C
      IF (IX(LM) .LT. IX(IPERM(K))) GO TO 110
      IPERM(K+1) = LM
      GO TO 100
C
C     Clean up
C
  120 IF (KFLAG .LE. -1) THEN
         DO 130 I=1,NN
            IX(I) = -IX(I)
  130    CONTINUE
      ENDIF
C
C     Rearrange the values of IX if desired
C
      IF (KK .EQ. 2) THEN
C
C        Use the IPERM vector as a flag.
C        If IPERM(I) < 0, then the I-th value is in correct location
C
         DO 150 ISTRT=1,NN
            IF (IPERM(ISTRT) .GE. 0)  THEN
               INDX = ISTRT
               INDX0 = INDX
               ITEMP = IX(ISTRT)
  140          IF (IPERM(INDX) .GT. 0)  THEN
                  IX(INDX) = IX(IPERM(INDX))
                  INDX0 = INDX
                  IPERM(INDX) = -IPERM(INDX)
                  INDX = ABS(IPERM(INDX))
                  GO TO 140
               ENDIF
               IX(INDX0) = ITEMP
            ENDIF
  150    CONTINUE
C
C        Revert the signs of the IPERM values
C
         DO 160 I=1,NN
            IPERM(I) = -IPERM(I)
  160    CONTINUE
C
      ENDIF
C
      RETURN
      END

      subroutine xermsg (c1,c2,c3,j,i)
      character*10 c1,c2
      character*80 c3
      integer i,j

      print *,'Message d erreur'
      print *,'****************'
      print *,'Subroutine : ',c2
      print *,c3
      if (i.eq.1) stop
      return
      end

      subroutine lecligne(ligne,nc)
      implicit none
      character*1000:: ligne
      integer ::i,j,k,l,nc
      i=1 
      j=len_trim(ligne) 
      do while(ligne(i:i).eq.' '.and.i.lt.j)
        i=i+1
        end do

      do while(ligne(j:j).eq.' '.and.j.gt.1)
        j=j-1
        end do

      nc=0
      do k=i,j-1
       if (ligne(k:k).ne.' '.and.ligne(k+1:k+1).eq.' ') nc=nc+1
       end do
      nc=nc+1
      return
      end
