C******** probabilite d'origine de genes (pog)
c calcule les pog d'une population de reference et trouve iterativement
c les ancetres les plus importants
c
c entree : fichier 1  : individu, pere, mere, annee naissance, sexe
c  les individus sont numerotes de 1 a n dans un ordre qcq
c  les parents inconnus sont codes <= 0
c  le fichier est trie par individu
c
      program prob_orig
      implicit none

      include "blk.incl"

      integer prc(nt), mrc(nt), ndes(nt)
      integer ord(nt)
      integer indi(nimp),pp(nimp),mm(nimp)
      real*8  prob(nt), pro(nt), pr1(nimp),pr2(nimp),x,y,cum,aj(nt),r,z
      integer*2 ann(nt), sex(nt), ngen(nt)
      integer i,j,k,l,n, nl, nbit,ip,im,ii,jj,npop,ng1, ng2, nfond,ngg
      integer numd,numf,nums,nim,ir4,ir5,ir6,nr
      real*8  sum,xr1,xr2,xmin,xmaj,eps
      logical t, pop(nt),chy
      character*128 str,sts,jour
c      real t1,t2,gtimer

      include "format.incl"

c fdate_ is a specific aix routine. Under standard unix, try fdate
      call fdate(jour)
      PRINT 990,jour

      numd=1995
      numf=1997
      nums=2
      nim=50
      eps=0.00000001d0

      print 1001
      read(5,*) str
      print 1002,str
      sts='no'
      print 1003
      read(5,*,end=12) sts
      print 1004,sts

      print 7001
      print 903

      read (5,*,end=12) nim,nums,numd,numf
      if (numd.lt.11) then
             numd=numd+2000
      else if (numd.lt.100) then
             numd=numd+1900
             end if
      if (numf.lt.11) then
             numf=numf+2000
      else if (numf.lt.100) then
             numf=numf+1900
             end if

   12 if (nim.gt.nimp) nim=nimp
      if (nums.lt.0.or.nums.gt.2) nums=2
      if (numd.gt.numf) then
        numd=1995
        numf=1997
        endif

      print 7002,nim,nums,numd,numf

c read file 1
      open (1,file=str,form='FORMATTED')
      nl=0
      chy=.false.

   10 read (1,*,end=20) i,ip,im,l,n
      NL=NL+1
      if (l.lt.11) then
             l=l+2000
             chy=.true.
      else if (l.lt.100) then
             l=l+1900
             chy=.true.
             end if
      if (i.ne.nl) then
          print 102,nl,i
          stop
          end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
          print 101
          stop
          end if
      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      ann(nl)=l
      sex(nl)=n
      GOTO 10

   20 if (chy) print 103
      print 900, nl
      close(1)
      

c initialisations
      do i=1, nl
         prob(i)=0.d0
         pop(i)=.false.
         ndes(i)=0
         end do

c compute number of progeny
      k=0
      do i=1, nl
        if (prc(i).ne.0) ndes(prc(i))=ndes(prc(i)) + 1
        if (mrc(i).ne.0) ndes(mrc(i))=ndes(mrc(i)) + 1
        end do
      do i=1, nl
        if (ndes(i).eq.0) k=k + 1
        end do
      print 7003, k
c construction de ngen et de ord
      k=0
      do i=1, nl
        ngen(i)=-1
        if (prc(i).eq.0 .and. mrc(i).eq.0)  then
            ngen(i)=0
            k=k+1
            ord(k)=i
        end if
      end do
      nbit=0
c we assume that the complete pedigree is ordered in less than 50 loops !
      do while(k.lt.nl .and. nbit.le.50)
        nbit=nbit+1
        j=0
        do i=1, nl
          if (ngen(i).lt.0) then
            ip=prc(i)
            im=mrc(i)
            t=.true.
            if (ip.ne.0 .and. ngen(ip).lt.0) t=.false.
            if (im.ne.0 .and. ngen(im).lt.0) t=.false.
            if (t) then
              if (ip.eq.0) then
                ii=0
              else
                ii=ngen(ip)
              end if
              if (im.ne.0) ii=max(ii,ngen(im))
              ngen(i) = ii+1
              k=k+1
              ord(k)=i
              j=j+1
            end if
          end if
        end do
c        print 1000,nbit,k,j,nl-k
      end do

c Check for pedigree
      j=0
      if (k.lt.nl) then
        print 1104, nl-k
        do i=1,nl
          if (ngen(i).lt.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',i,prc(i),mrc(i)
            prc(i)=0
            mrc(i)=0
            ngen(i)=0
            k=k+1
            ord(k)=i
            end if
        end do
       end if

c define ref population
      npop=0
      ng1=0
      ng2=0
      do i=1, nl
        if (ann(i).ge.numd .and. ann(i).le.numf .and. sex(i).eq.nums
     *       .and. prc(i).ne.0  .and.  mrc(i).ne.0) then
          prob(i)=1.d0
          pop(i)=.true.
          npop=npop+1
          ng1=max(ng1,ngen(i))
        else
          ng2=max(ng2,ngen(i))
          end if
        end do

      print 7005,npop
      ngg=max(ng1,ng2)

c calcul des probas d'origine des genes avec les fondateurs initiaux
c on traite d'abord la population de depart
      do k=nl,1,-1
        i=ord(k)
        if (pop(i)) then
          ip=prc(i)
          im=mrc(i)
          if (ip.ne.0) prob(ip)=prob(ip) + prob(i)*.5d0
          if (im.ne.0) prob(im)=prob(im) + prob(i)*.5d0
          end if
        end do

c on traite ensuite les autres
      do k=nl,1,-1
        i=ord(k)
        if (.not.pop(i)) then
          ip=prc(i)
          im=mrc(i)
          if (ip.ne.0) prob(ip)=prob(ip) + prob(i)*.5d0
          if (im.ne.0) prob(im)=prob(im) + prob(i)*.5d0
          end if
        end do

       x=0.d0
      do i=1, nl
        if (prc(i).eq.0 .and. mrc(i).eq.0 .and. .not.pop(i)
     *     .and.  prob(i).gt.0.d0)  then
           nfond=nfond+1
           y=prob(i)/dfloat(npop)
           x=x + y*y
        else if ((prc(i).eq.0 .or. mrc(i).eq.0) .and. .not.pop(i)
     *     .and.  prob(i).gt.0.d0)  then
           y=prob(i)*.5d0/dfloat(npop)
           x=x + y*y
           nfond=nfond+1
           end if
         end do

       x=1.d0/x
       print 7006,nfond
       print 7007,x

c sauvegarde des resultats des fondateurs initiaux
      if (sts.ne.'no') then
        open (2,file=sts,form='FORMATTED')
        do i=1, nl
         if (prob(i).gt.0.d0 .and. .not.pop(i)) then
          z=prob(i)/dfloat(npop)
          if (prc(i).eq.0 .and. mrc(i).eq.0) then
             y=z
          else if (prc(i).eq.0 .or. mrc(i).eq.0) then
             y=.5d0*z
          else
             y=0.d0
             end if
           write (2,'(i10,2f10.6)') i,y,z
           end if
          end do
         close (2)
         end if


c recherche des nim individus les importants
      cum=0.d0
      sum=0.d0
      print 7008
c       t1=gtimer()
c transfert de prob dans pro
      do i=1, nl
        pro(i)=prob(i)
        end do


c $$$$$$$$$$$$   analyse du lme fondateur $$$$$$$$$$$$$$$$$$$$
      l=0
      open (3,file='list_ancestors',form='formatted')

      do while(l.lt.nim .and. cum.lt.1.d0-eps)
        l=l+1
c        if (l.eq.11) then
c gtimer is a unix specific function....
c          t2=gtimer()
c          print *,'CPU par fondateur : ', (t2-t1)*.1
c          end if
c a:recherche de pro maxi
        x=0.d0
        do i=1, l-1
          pro(indi(i))=0.d0
          end do
        do i=1, nl
          if (x.lt.pro(i).and..not.pop(i)) then  !! ancetre en dehors de la pop ref
            j=i                                 !! 9/04/97
            x=pro(i)
            end if
          end do

c calcul des majorant et minorant
        x=prob(j)/dfloat(npop)
        y=pro(j)/dfloat(npop)
        cum=cum + y
        sum=sum + y*y
        indi(l)=j
        r=y
        if (r.gt.0.d0) then
          nr=int((1.d0-cum)/r)
          z=1.d0 - cum - dfloat(nr)*r
        else
          nr=0
          z=0.d0
          end if
        xmin=1.d0 / (sum + dfloat(nr)*r*r + z*z)
        nr=nfond - l
        if (nr.gt.0) then
          r=(1.d0-cum)/dfloat(nr)
        else
          r=0.d0
          end if
        xmaj=1.d0/(sum + dfloat(nr)*r*r)
        print 7009,l,j,sex(j),ann(j),
     *      x,y,cum,prc(j),mrc(j),ndes(j),xmin,xmaj
        write (3,'(i8,i4,i2,i5,3i9,f8.4,2f12.4,2f10.2)') 
     *	    j,l,sex(j),ann(j),prc(j),mrc(j),ndes(j),
     *      x,y,cum,xmin,xmaj

c b: sauvegarde, annulation de genealogie, reinitialisation de pro
        pr1(l)=x
        pr2(l)=y
        prc(j)=0
        mrc(j)=0
c initialisation
        do i=1, nl
          if (pop(i)) then
            pro(i)=1.d0
          else
            pro(i)=0.d0
            end if
          end do
c c: calcul des pro
c on traite d'abord la population de depart
        do k=nl,1,-1
          i=ord(k)
          if (pop(i)) then
            ip=prc(i)
            im=mrc(i)
            if (ip.ne.0) pro(ip)=pro(ip) + pro(i)*.5d0
            if (im.ne.0) pro(im)=pro(im) + pro(i)*.5d0
            end if
          end do

c on traite ensuite les autres
        do k=nl,1,-1
          i=ord(k)
          if (.not.pop(i)) then
            ip=prc(i)
            im=mrc(i)
            if (ip.ne.0) pro(ip)=pro(ip) + pro(i)*.5d0
            if (im.ne.0) pro(im)=pro(im) + pro(i)*.5d0
            end if
          end do

c d: ajustements pour les ancetres deja choisis
        do i=1, nl
          aj(i)=0.d0
          end do
        do i=1, l
          ii=indi(i)
          aj(ii)=1.d0
          end do
        do k=1,nl
          i=ord(k)
          ip=prc(i)
          if (ip.ne.0 .and. aj(ip).ne.0.d0)
     *              aj(i)=aj(i) + .5d0*aj(ip)
          im=mrc(i)
          if (im.ne.0 .and. aj(im).ne.0.d0)
     *              aj(i)=aj(i) + .5d0*aj(im)
          end do
        do i=1, nl
          pro(i)=pro(i)*(1.d0 - aj(i))
          end do
c fin
        end do

      print 7010,xmin,xmaj
      close (3)

      stop
      END
